#!/usr/bin/python -t
#coding=utf-8

import sys
import hotshot
import subprocess
import hotshot.stats
import sectool

argc = len(sys.argv)
if argc < 2:
    print "Usage: makeprof.py <profile-name> <sectool-arguments>"
    print "Example: makeprof.py myprofile --run home_files"
    sys.exit(1)

profname = sys.argv[1]
prof = hotshot.Profile(profname)

print "Running a profiled run, output will be saved in file %s" % profname
prof.runcall(sectool.main, sys.argv[2:])
print "Profiled run finished"

print "Creating cachegrind file from profile data. This may take a long time"
proc = subprocess.Popen('hotshot2calltree %s >%s.cachegrind' % (profname, profname), shell=True)
proc.wait()
print "Generating cachegrind finished"

print "Formatting data.."
stats = hotshot.stats.load(profname)
stats.strip_dirs()
stats.sort_stats('time', 'calls')
stats.print_stats(30)
sys.exit(0)

